from colorama import Fore
from colorama import init
from termcolor import colored
from colorama import Fore, Back, Style
init() # can use {Back.(colour)} to highlight text
white_square = f"{Style.DIM}{Fore.WHITE}- {Fore.WHITE}{Style.NORMAL}"
black_square = f"{Style.DIM}{Fore.YELLOW}+ {Fore.WHITE}{Style.NORMAL}"
W_pawn = f"{Style.BRIGHT}{Fore.CYAN}P {Fore.WHITE}{Style.NORMAL}"
W_rook = f"{Style.BRIGHT}{Fore.CYAN}R {Fore.WHITE}{Style.NORMAL}"
W_knight = f"{Style.BRIGHT}{Fore.CYAN}H {Fore.WHITE}{Style.NORMAL}" # H (horse) for knight is taken by the more important king
W_bishop = f"{Style.BRIGHT}{Fore.CYAN}B {Fore.WHITE}{Style.NORMAL}"
W_queen = f"{Style.BRIGHT}{Fore.CYAN}Q {Fore.WHITE}{Style.NORMAL}"
W_king = f"{Style.BRIGHT}{Fore.CYAN}K {Fore.WHITE}{Style.NORMAL}"

B_pawn = f"{Style.BRIGHT}{Fore.RED}P {Fore.WHITE}{Style.NORMAL}" # BRIGHT looks pink and makes it less like the colour black 
B_rook = f"{Style.BRIGHT}{Fore.RED}R {Fore.WHITE}{Style.NORMAL}" # DIM is darker in terminal than in IDE
B_knight = f"{Style.BRIGHT}{Fore.RED}H {Fore.WHITE}{Style.NORMAL}" # Oh well, pink it is I guess
B_bishop = f"{Style.BRIGHT}{Fore.RED}B {Fore.WHITE}{Style.NORMAL}"
B_queen = f"{Style.BRIGHT}{Fore.RED}Q {Fore.WHITE}{Style.NORMAL}"
B_king = f"{Style.BRIGHT}{Fore.RED}K {Fore.WHITE}{Style.NORMAL}"

black_tiles = ["a1", "a3", "a5", "a7", "b2", "b4", "b6", "b8", "c1", "c3", "c5", "c7", "d2", "d4", "d6", "d8", "e1", "e3", "e5", "e7", "f2", "f4", "f6", "f8", "g1", "g3", "g5", "g7", "h2", "h4", "h6", "h8"]
pieces = {}
alphabet = ["a", "b", "c", "d", "e", "f", "g", "h"]
number_list = ["1", "2", "3", "4", "5", "6", "7", "8"]
for k in range(7):
    for i in range(7 + 1):
        #print(alphabet[k] + str(i + 1))
        if alphabet[k] + str(i + 1) in black_tiles: 
            pieces[alphabet[k] + str(i + 1)] = black_square
        else:
            pieces[alphabet[k] + str(i + 1)] = white_square

#set starter pieces, easier to look at when manually typed out (and it works fine as it is)        
white_pieces = [W_rook, W_knight, W_bishop, W_king, W_queen, W_pawn]
black_pieces = [B_rook, B_knight, B_bishop, B_king, B_queen, B_pawn]
pieces["a1"] = W_rook
pieces["a2"] = W_knight
pieces["a3"] = W_bishop
pieces["a4"] = W_king
pieces["a5"] = W_queen
pieces["a6"] = W_bishop
pieces["a7"] = W_knight
pieces["a8"] = W_rook
pieces["b1"] = W_pawn
pieces["b2"] = W_pawn
pieces["b3"] = W_pawn
pieces["b4"] = W_pawn 
pieces["b5"] = W_pawn
pieces["b6"] = W_pawn
pieces["b7"] = W_pawn 
pieces["b8"] = W_pawn
pieces["g1"] = B_pawn
pieces["g2"] = B_pawn
pieces["g3"] = B_pawn
pieces["g4"] = B_pawn
pieces["g5"] = B_pawn
pieces["g6"] = B_pawn
pieces["g7"] = B_pawn
pieces["g8"] = B_pawn
pieces["h1"] = B_rook
pieces["h2"] = B_knight
pieces["h3"] = B_bishop
pieces["h4"] = B_king
pieces["h5"] = B_queen
pieces["h6"] = B_bishop
pieces["h7"] = B_knight
pieces["h8"] = B_rook
W_king_location = "a4"
B_king_location = "h4"
global king_dead
king_dead = False
total_W_pawn_count = 8
total_W_knight_count = 2
total_W_bishop_count = 2
total_W_rook_count = 2
total_W_queen_count = 1
total_B_pawn_count = 8
total_B_knight_count = 2
total_B_bishop_count = 2
total_B_rook_count = 2
total_B_queen_count = 1
def get_board():
    global visual_board
    global colour
    global W_dead_pieces
    global B_dead_pieces
    if player_turn == "white":
        colour = Fore.CYAN
    elif player_turn == "black":
        colour = Fore.RED
    if king_dead == True:
        colour = Fore.MAGENTA
    piece_count = []
    W_pawn_count = 0
    W_rook_count = 0
    W_knight_count = 0
    W_bishop_count = 0
    W_queen_count = 0
    W_king_count = 0
    B_pawn_count = 0
    B_rook_count = 0
    B_knight_count = 0
    B_bishop_count = 0
    B_queen_count = 0
    B_king_count = 0
    B_dead_pieces = []
    W_dead_pieces = []
    dead_W_pawns_list = []
    dead_W_rooks_list = []
    dead_W_knights_list = []
    dead_W_bishops_list = []
    dead_W_queens_list = []
    dead_W_kings_list = []
    dead_B_pawns_list = []
    dead_B_rooks_list = []
    dead_B_knights_list = []
    dead_B_bishops_list = []
    dead_B_queens_list = []
    dead_B_kings_list = []
    for k in range(8):
        for i in range(8):
            piece_count.append(pieces.get(alphabet[k] + str(i + 1)))
    for i in range(len(piece_count)):
        if piece_count[i] == W_pawn:
            W_pawn_count += 1
        dead_W_pawns = total_W_pawn_count - W_pawn_count
        if piece_count[i] == W_rook:
            W_rook_count += 1
        dead_W_rooks = total_W_rook_count - W_rook_count
        if piece_count[i] == W_knight:
            W_knight_count += 1
        dead_W_knights = total_W_knight_count - W_knight_count 
        if piece_count[i] == W_bishop:
            W_bishop_count += 1
        dead_W_bishops = total_W_bishop_count - W_bishop_count
        if piece_count[i] == W_queen:
            W_queen_count += 1
        dead_W_queens = total_W_queen_count - W_queen_count
        if piece_count[i] == W_king:
            W_king_count += 1
        dead_W_kings = 1 - W_king_count
        if piece_count[i] == B_pawn:
            B_pawn_count += 1
        dead_B_pawns = total_B_pawn_count - B_pawn_count
        if piece_count[i] == B_rook:
            B_rook_count += 1
        dead_B_rooks = total_B_rook_count - B_rook_count
        if piece_count[i] == B_knight:
            B_knight_count += 1
        dead_B_knights = total_B_knight_count - B_knight_count
        if piece_count[i] == B_bishop:
            B_bishop_count += 1
        dead_B_bishops = total_B_bishop_count - B_bishop_count
        if piece_count[i] == B_queen:
            B_queen_count += 1
        dead_B_queens = total_B_queen_count - B_queen_count
        if piece_count[i] == B_king:
            B_king_count += 1
        dead_B_kings = 1 - B_king_count
    for i in range(dead_W_pawns):
        W_dead_pieces.append(W_pawn)
    for i in range(dead_W_rooks):
        W_dead_pieces.append(W_rook)
    for i in range(dead_W_knights):
        W_dead_pieces.append(W_knight)
    for i in range(dead_W_bishops):
        W_dead_pieces.append(W_bishop)
    for i in range(dead_W_queens):
        W_dead_pieces.append(W_queen)
    for i in range(dead_W_kings):
        W_dead_pieces.append(W_king)
    for i in range(dead_B_pawns):
        B_dead_pieces.append(B_pawn)
    for i in range(dead_B_rooks):
        B_dead_pieces.append(B_rook)
    for i in range(dead_B_knights):
        B_dead_pieces.append(B_knight)
    for i in range(dead_B_bishops):
        B_dead_pieces.append(B_bishop)
    for i in range(dead_B_queens):
        B_dead_pieces.append(B_queen)
    for i in range(dead_B_kings):
        B_dead_pieces.append(B_king)
    if len(B_dead_pieces) == 0:
        B_dead_pieces = "Desolate..."
    if len(W_dead_pieces) == 0:
        W_dead_pieces = "Dismal..."
    board = [f"{colour} _ _ _ _ _ _ _ _ _ \n", # yes letter and number ranks are the wrong way round, but there's nothing I can do as the math all over the code is build onti this format
            f"{colour}|{Fore.WHITE}", str(pieces.get("a1")), str(pieces.get("a2")), str(pieces.get("a3")), str(pieces.get("a4")), str(pieces.get("a5")), str(pieces.get("a6")), str(pieces.get("a7")), str(pieces.get("a8")), f"{Fore.GREEN}a{colour}" + "| ", f"{Fore.MAGENTA}Black's graveyard: \n",  
            f"{colour}|{Fore.WHITE}", str(pieces.get("b1")), str(pieces.get("b2")), str(pieces.get("b3")), str(pieces.get("b4")), str(pieces.get("b5")), str(pieces.get("b6")), str(pieces.get("b7")), str(pieces.get("b8")), f"{Fore.GREEN}b{colour}" + f"| {Fore.RED}", "".join(B_dead_pieces), "\n", 
            f"{colour}|{Fore.WHITE}", str(pieces.get("c1")), str(pieces.get("c2")), str(pieces.get("c3")), str(pieces.get("c4")), str(pieces.get("c5")), str(pieces.get("c6")), str(pieces.get("c7")), str(pieces.get("c8")), f"{Fore.GREEN}c{colour}" + "|\n", 
            f"{colour}|{Fore.WHITE}", str(pieces.get("d1")), str(pieces.get("d2")), str(pieces.get("d3")), str(pieces.get("d4")), str(pieces.get("d5")), str(pieces.get("d6")), str(pieces.get("d7")), str(pieces.get("d8")), f"{Fore.GREEN}d{colour}" + "|\n", 
            f"{colour}|{Fore.WHITE}", str(pieces.get("e1")), str(pieces.get("e2")), str(pieces.get("e3")), str(pieces.get("e4")), str(pieces.get("e5")), str(pieces.get("e6")), str(pieces.get("e7")), str(pieces.get("e8")), f"{Fore.GREEN}e{colour}" + "|\n", 
            f"{colour}|{Fore.WHITE}", str(pieces.get("f1")), str(pieces.get("f2")), str(pieces.get("f3")), str(pieces.get("f4")), str(pieces.get("f5")), str(pieces.get("f6")), str(pieces.get("f7")), str(pieces.get("f8")), f"{Fore.GREEN}f{colour}" + "|\n", 
            f"{colour}|{Fore.WHITE}", str(pieces.get("g1")), str(pieces.get("g2")), str(pieces.get("g3")), str(pieces.get("g4")), str(pieces.get("g5")), str(pieces.get("g6")), str(pieces.get("g7")), str(pieces.get("g8")), f"{Fore.GREEN}g{colour}" + "| ", f"{Fore.MAGENTA}White's graveyard: \n",  
            f"{colour}|{Fore.WHITE}", str(pieces.get("h1")), str(pieces.get("h2")), str(pieces.get("h3")), str(pieces.get("h4")), str(pieces.get("h5")), str(pieces.get("h6")), str(pieces.get("h7")), str(pieces.get("h8")), f"{Fore.GREEN}h{colour}" + f"| {Fore.CYAN}", "".join(W_dead_pieces), "\n", 
            f"{colour}|{Fore.WHITE}", f"{Fore.GREEN}1 2 3 4 5 6 7 8 @{colour}|", f"\n — — — — — — — — —\n{Fore.WHITE}"]
    visual_board = "".join(board)
def check_checker_white(): # checks location of every piece, then checks all possible moves each piece can do
    valid_locations = []   # if White king is in one of those kill zones then it's a check
    global kill_zones
    black_pieces_locations = []
    for k in range(8):
        for i in range(8):
            if pieces.get(alphabet[k] + str(i + 1)) in black_pieces: 
                black_pieces_locations.append(alphabet[k] + str(i + 1))
    for i in range(len(black_pieces_locations)):
        to_move = black_pieces_locations[i]
        character_axis = list(to_move)[0]
        number_axis = int(list(to_move)[1])
        locations_to_remove = []
        if pieces.get(to_move) == B_rook: # rook's code
            piece = "Rook"
            full_piece_name = piece + " " + to_move
            number_axis = str(number_axis)
            for i in range(1, 8):
                if pieces.get(str((chr(ord(character_axis) + i)) + str(number_axis))) in black_pieces:
                    break
                elif pieces.get(str((chr(ord(character_axis) + i)) + str(number_axis))) in white_pieces:
                    valid_locations.append(str((chr(ord(character_axis) + i)) + str(number_axis)))
                    break
                valid_locations.append(str((chr(ord(character_axis) + i)) + str(number_axis)))
            for i in range(1, 8):
                if pieces.get(str((chr(ord(character_axis) - i)) + str(number_axis))) in black_pieces:
                    break
                elif pieces.get(str((chr(ord(character_axis) - i)) + str(number_axis))) in white_pieces:
                    valid_locations.append(str((chr(ord(character_axis) - i)) + str(number_axis)))
                    break
                valid_locations.append(str((chr(ord(character_axis) - i)) + str(number_axis)))
            for i in range(1, 8):
                if pieces.get(character_axis + str(int(number_axis) + i)) in black_pieces:
                    break
                elif pieces.get(character_axis + str(int(number_axis) + i)) in white_pieces:
                    valid_locations.append(str((chr(ord(character_axis) + i)) + str(number_axis)))
                    break
                valid_locations.append(character_axis + str(int(number_axis) + i))
            for i in range(1, 8):
                if pieces.get(character_axis + str(int(number_axis) - i)) in black_pieces:
                    break
                elif pieces.get(character_axis + str(int(number_axis) - i)) in white_pieces:
                    valid_locations.append(str((chr(ord(character_axis) - i)) + str(number_axis)))
                    break
                valid_locations.append(character_axis + str(int(number_axis) - i))
            for i in range(len(valid_locations)):
                if list(valid_locations[i])[0] not in alphabet or list(valid_locations[i])[1] not in number_list or len(valid_locations[i]) > 2:
                    locations_to_remove.append(valid_locations[i])
                if pieces.get(valid_locations[i]) in black_pieces:
                    locations_to_remove.append(valid_locations[i])
            for i in range(len(locations_to_remove)):
                if locations_to_remove[i] in valid_locations:
                    valid_locations.remove(locations_to_remove[i])
        elif pieces.get(to_move) == B_knight: # knight's code
            piece = "Knight"
            full_piece_name = piece + " " + to_move
            valid_locations.append(chr(ord(character_axis) - 2) + str(number_axis - 1)) #1
            valid_locations.append(chr(ord(character_axis) - 2) + str(number_axis + 1)) #2
            valid_locations.append(chr(ord(character_axis) - 1) + str(number_axis + 2)) #3
            valid_locations.append(chr(ord(character_axis) + 1) + str(number_axis + 2)) #4
            valid_locations.append(chr(ord(character_axis) + 2) + str(number_axis + 1)) #5
            valid_locations.append(chr(ord(character_axis) + 2) + str(number_axis - 1)) #6
            valid_locations.append(chr(ord(character_axis) + 1) + str(number_axis - 2)) #7
            valid_locations.append(chr(ord(character_axis) - 1) + str(number_axis - 2)) #8
            for i in range(len(valid_locations)):
                if list(valid_locations[i])[0] not in alphabet or str(list(valid_locations[i])[1]) not in number_list or pieces.get(valid_locations[i]) in black_pieces or len(valid_locations[i]) > 2:
                    locations_to_remove.append(valid_locations[i])
            for i in range(len(locations_to_remove)):
                if locations_to_remove[i] in valid_locations:
                    valid_locations.remove(locations_to_remove[i])
        elif pieces.get(to_move) == B_bishop: # bishop's code
            piece = "Bishop"
            full_piece_name = piece + " " + to_move
            for i in range(1, 8): #1
                if pieces.get(chr(ord(character_axis) + i) + str(number_axis + i)) in black_pieces:
                    break
                elif pieces.get(chr(ord(character_axis) + i) + str(number_axis + i)) in white_pieces:
                    valid_locations.append(chr(ord(character_axis) + i) + str(number_axis + i))
                    break
                valid_locations.append(chr(ord(character_axis) + i) + str(number_axis + i))
            for i in range(1, 8): #2
                if pieces.get(chr(ord(character_axis) + i) + str(number_axis - i)) in black_pieces:
                    break
                elif pieces.get(chr(ord(character_axis) + i) + str(number_axis - i)) in white_pieces:
                    valid_locations.append(chr(ord(character_axis) + i) + str(number_axis - i))
                    break
                valid_locations.append(chr(ord(character_axis) + i) + str(number_axis - i))
            for i in range(1, 8): #3
                if pieces.get(chr(ord(character_axis) - i) + str(number_axis + i)) in black_pieces:
                    break
                elif pieces.get(chr(ord(character_axis) - i) + str(number_axis + i)) in white_pieces:
                    valid_locations.append(chr(ord(character_axis) - i) + str(number_axis + i))
                    break
                valid_locations.append(chr(ord(character_axis) + i) + str(number_axis - i))
            for i in range(1, 8): #4
                if pieces.get(chr(ord(character_axis) - i) + str(number_axis - i)) in black_pieces:
                    break
                elif pieces.get(chr(ord(character_axis) - i) + str(number_axis - i)) in white_pieces:
                    valid_locations.append(chr(ord(character_axis) - i) + str(number_axis - i))
                    break
                valid_locations.append(chr(ord(character_axis) + i) + str(number_axis - i))
            for i in range(len(valid_locations)):
                if list(valid_locations[i])[0] not in alphabet or str(list(valid_locations[i])[1]) not in number_list or len(valid_locations[i]) > 2:
                    locations_to_remove.append(valid_locations[i])
            for i in range(len(locations_to_remove)):
                if locations_to_remove[i] in valid_locations:
                    valid_locations.remove(locations_to_remove[i])
        elif pieces.get(to_move) == B_queen: # queens's code
            piece = "Queen"
            full_piece_name = piece + " " + to_move
            for i in range(1, 8):
                if pieces.get(str((chr(ord(character_axis) + i)) + str(number_axis))) in black_pieces:
                    break
                elif pieces.get(str((chr(ord(character_axis) + i)) + str(number_axis))) in white_pieces:
                    valid_locations.append(str((chr(ord(character_axis) + i)) + str(number_axis)))
                    break
                valid_locations.append(str((chr(ord(character_axis) + i)) + str(number_axis)))
            for i in range(1, 8):
                if pieces.get(str((chr(ord(character_axis) - i)) + str(number_axis))) in black_pieces:
                    break
                elif pieces.get(str((chr(ord(character_axis) - i)) + str(number_axis))) in white_pieces:
                    valid_locations.append(str((chr(ord(character_axis) - i)) + str(number_axis)))
                    break
                valid_locations.append(str((chr(ord(character_axis) - i)) + str(number_axis)))
            for i in range(1, 8):
                if pieces.get(character_axis + str(int(number_axis) + i)) in black_pieces:
                    break
                elif pieces.get(character_axis + str(int(number_axis) + i)) in white_pieces:
                    valid_locations.append(str((chr(ord(character_axis) + i)) + str(number_axis)))
                    break
                valid_locations.append(character_axis + str(int(number_axis) + i))
            for i in range(1, 8):
                if pieces.get(character_axis + str(int(number_axis) - i)) in black_pieces:
                    break
                elif pieces.get(character_axis + str(int(number_axis) - i)) in white_pieces:
                    valid_locations.append(str((chr(ord(character_axis) - i)) + str(number_axis)))
                    break
                valid_locations.append(character_axis + str(int(number_axis) - i))
            for i in range(1, 8): #1
                if pieces.get(chr(ord(character_axis) + i) + str(number_axis + i)) in black_pieces:
                    break
                elif pieces.get(chr(ord(character_axis) + i) + str(number_axis + i)) in white_pieces:
                    valid_locations.append(chr(ord(character_axis) + i) + str(number_axis + i))
                    break
                valid_locations.append(chr(ord(character_axis) + i) + str(number_axis + i))
            for i in range(1, 8): #2
                if pieces.get(chr(ord(character_axis) + i) + str(number_axis - i)) in black_pieces:
                    break
                elif pieces.get(chr(ord(character_axis) + i) + str(number_axis - i)) in white_pieces:
                    valid_locations.append(chr(ord(character_axis) + i) + str(number_axis - i))
                    break
                valid_locations.append(chr(ord(character_axis) + i) + str(number_axis - i))
            for i in range(1, 8): #3
                if pieces.get(chr(ord(character_axis) - i) + str(number_axis + i)) in black_pieces:
                    break
                elif pieces.get(chr(ord(character_axis) - i) + str(number_axis + i)) in white_pieces:
                    valid_locations.append(chr(ord(character_axis) - i) + str(number_axis + i))
                    break
                valid_locations.append(chr(ord(character_axis) - i) + str(number_axis + i))
            for i in range(1, 8): #4
                if pieces.get(chr(ord(character_axis) - i) + str(number_axis - i)) in black_pieces:
                    break
                elif pieces.get(chr(ord(character_axis) - i) + str(number_axis - i)) in white_pieces:
                    valid_locations.append(chr(ord(character_axis) - i) + str(number_axis - i))
                    break
                valid_locations.append(chr(ord(character_axis) - i) + str(number_axis - i))
            for i in range(len(valid_locations)):
                if list(valid_locations[i])[0] not in alphabet or str(list(valid_locations[i])[1]) not in number_list or len(valid_locations[i]) > 2:
                    locations_to_remove.append(valid_locations[i])
            if list(valid_locations[i])[0] not in alphabet or str(list(valid_locations[i])[1]) not in number_list or len(valid_locations[i]) > 2:
                    locations_to_remove.append(valid_locations[i])
            for i in range(len(locations_to_remove)):
                if locations_to_remove[i] in valid_locations:
                    valid_locations.remove(locations_to_remove[i])
        elif pieces.get(to_move) == B_pawn: # pawn's code
            piece = "Pawn" 
            full_piece_name = piece + " " + to_move
            valid_locations.append(chr(ord(character_axis) - 1) + str(number_axis + 1))
            valid_locations.append(chr(ord(character_axis) - 1) + str(number_axis - 1))
        elif pieces.get(to_move) == B_king: # king's code
            piece = "King" 
            full_piece_name = piece + " " + to_move
            for i in range(1, 2): # recycled queen code but for 1 square in all directions
                if pieces.get(str((chr(ord(character_axis) + i)) + str(number_axis))) in black_pieces:
                    break
                elif pieces.get(str((chr(ord(character_axis) + i)) + str(number_axis))) in white_pieces:
                    valid_locations.append(str((chr(ord(character_axis) + i)) + str(number_axis)))
                    break
                valid_locations.append(str((chr(ord(character_axis) + i)) + str(number_axis)))
            for i in range(1, 2):
                if pieces.get(str((chr(ord(character_axis) - i)) + str(number_axis))) in black_pieces:
                    break
                elif pieces.get(str((chr(ord(character_axis) - i)) + str(number_axis))) in white_pieces:
                    valid_locations.append(str((chr(ord(character_axis) - i)) + str(number_axis)))
                    break
                valid_locations.append(str((chr(ord(character_axis) - i)) + str(number_axis)))
            for i in range(1, 2):
                if pieces.get(character_axis + str(int(number_axis) + i)) in black_pieces:
                    break
                elif pieces.get(character_axis + str(int(number_axis) + i)) in white_pieces:
                    valid_locations.append(str((chr(ord(character_axis) + i)) + str(number_axis)))
                    break
                valid_locations.append(character_axis + str(int(number_axis) + i))
            for i in range(1, 2):
                if pieces.get(character_axis + str(int(number_axis) - i)) in black_pieces:
                    break
                elif pieces.get(character_axis + str(int(number_axis) - i)) in white_pieces:
                    valid_locations.append(str((chr(ord(character_axis) - i)) + str(number_axis)))
                    break
                valid_locations.append(character_axis + str(int(number_axis) - i))
            for i in range(1, 2): #1
                if pieces.get(chr(ord(character_axis) + i) + str(number_axis + i)) in black_pieces:
                    break
                elif pieces.get(chr(ord(character_axis) + i) + str(number_axis + i)) in white_pieces:
                    valid_locations.append(chr(ord(character_axis) + i) + str(number_axis + i))
                    break
                valid_locations.append(chr(ord(character_axis) + i) + str(number_axis + i))
            for i in range(1, 2): #2
                if pieces.get(chr(ord(character_axis) + i) + str(number_axis - i)) in black_pieces:
                    break
                elif pieces.get(chr(ord(character_axis) + i) + str(number_axis - i)) in white_pieces:
                    valid_locations.append(chr(ord(character_axis) + i) + str(number_axis - i))
                    break
                valid_locations.append(chr(ord(character_axis) + i) + str(number_axis - i))
            for i in range(1, 2): #3
                if pieces.get(chr(ord(character_axis) - i) + str(number_axis + i)) in black_pieces:
                    break
                elif pieces.get(chr(ord(character_axis) - i) + str(number_axis + i)) in white_pieces:
                    valid_locations.append(chr(ord(character_axis) - i) + str(number_axis + i))
                    break
                valid_locations.append(chr(ord(character_axis) + i) + str(number_axis - i))
            for i in range(1, 2): #4
                if pieces.get(chr(ord(character_axis) - i) + str(number_axis - i)) in black_pieces:
                    break
                elif pieces.get(chr(ord(character_axis) - i) + str(number_axis - i)) in white_pieces:
                    valid_locations.append(chr(ord(character_axis) - i) + str(number_axis - i))
                    break
                valid_locations.append(chr(ord(character_axis) + i) + str(number_axis - i))
            for i in range(len(valid_locations)):
                if list(valid_locations[i])[0] not in alphabet or str(list(valid_locations[i])[1]) not in number_list or len(valid_locations[i]) > 2:
                    locations_to_remove.append(valid_locations[i])
            for i in range(len(locations_to_remove)):
                if locations_to_remove[i] in valid_locations:
                    valid_locations.remove(locations_to_remove[i])
    kill_zones = list(dict.fromkeys(valid_locations))
def check_checker_black(): # opposite as above code, in terms of colours
    global kill_zones
    valid_locations = []
    white_pieces_locations = []
    for k in range(8):
        for i in range(8):
            if pieces.get(alphabet[k] + str(i + 1)) in white_pieces: 
                white_pieces_locations.append(alphabet[k] + str(i + 1))
    for i in range(len(white_pieces_locations)):
        to_move = white_pieces_locations[i]
        character_axis = list(to_move)[0]
        number_axis = int(list(to_move)[1])
        locations_to_remove = []
        if pieces.get(to_move) == W_rook: # rook's code
            piece = "Rook"
            full_piece_name = piece + " " + to_move
            number_axis = str(number_axis)
            for i in range(1, 8):
                if pieces.get(str((chr(ord(character_axis) + i)) + str(number_axis))) in white_pieces:
                    break
                elif pieces.get(str((chr(ord(character_axis) + i)) + str(number_axis))) in black_pieces:
                    valid_locations.append(str((chr(ord(character_axis) + i)) + str(number_axis)))
                    break
                valid_locations.append(str((chr(ord(character_axis) + i)) + str(number_axis)))
            for i in range(1, 8):
                if pieces.get(str((chr(ord(character_axis) - i)) + str(number_axis))) in white_pieces:
                    break
                elif pieces.get(str((chr(ord(character_axis) - i)) + str(number_axis))) in black_pieces:
                    valid_locations.append(str((chr(ord(character_axis) - i)) + str(number_axis)))
                    break
                valid_locations.append(str((chr(ord(character_axis) - i)) + str(number_axis)))
            for i in range(1, 8):
                if pieces.get(character_axis + str(int(number_axis) + i)) in white_pieces:
                    break
                elif pieces.get(character_axis + str(int(number_axis) + i)) in black_pieces:
                    valid_locations.append(str((chr(ord(character_axis) + i)) + str(number_axis)))
                    break
                valid_locations.append(character_axis + str(int(number_axis) + i))
            for i in range(1, 8):
                if pieces.get(character_axis + str(int(number_axis) - i)) in white_pieces:
                    break
                elif pieces.get(character_axis + str(int(number_axis) - i)) in black_pieces:
                    valid_locations.append(str((chr(ord(character_axis) - i)) + str(number_axis)))
                    break
                valid_locations.append(character_axis + str(int(number_axis) - i))
            for i in range(len(valid_locations)):
                if list(valid_locations[i])[0] not in alphabet or list(valid_locations[i])[1] not in number_list or len(valid_locations[i]) > 2:
                    locations_to_remove.append(valid_locations[i])
                if pieces.get(valid_locations[i]) in white_pieces:
                    locations_to_remove.append(valid_locations[i])
            for i in range(len(locations_to_remove)):
                if locations_to_remove[i] in valid_locations:
                    valid_locations.remove(locations_to_remove[i])
        elif pieces.get(to_move) == W_knight: # knight's code
            piece = "Knight"
            full_piece_name = piece + " " + to_move
            valid_locations.append(chr(ord(character_axis) - 2) + str(number_axis - 1)) #1
            valid_locations.append(chr(ord(character_axis) - 2) + str(number_axis + 1)) #2
            valid_locations.append(chr(ord(character_axis) - 1) + str(number_axis + 2)) #3
            valid_locations.append(chr(ord(character_axis) + 1) + str(number_axis + 2)) #4
            valid_locations.append(chr(ord(character_axis) + 2) + str(number_axis + 1)) #5
            valid_locations.append(chr(ord(character_axis) + 2) + str(number_axis - 1)) #6
            valid_locations.append(chr(ord(character_axis) + 1) + str(number_axis - 2)) #7
            valid_locations.append(chr(ord(character_axis) - 1) + str(number_axis - 2)) #8
            for i in range(len(valid_locations)):
                if list(valid_locations[i])[0] not in alphabet or str(list(valid_locations[i])[1]) not in number_list or pieces.get(valid_locations[i]) in white_pieces or len(valid_locations[i]) > 2:
                    locations_to_remove.append(valid_locations[i])
            for i in range(len(locations_to_remove)):
                if locations_to_remove[i] in valid_locations:
                    valid_locations.remove(locations_to_remove[i])
        elif pieces.get(to_move) == W_bishop: # bishop's code
            piece = "Bishop"
            full_piece_name = piece + " " + to_move
            for i in range(1, 8): #1
                if pieces.get(chr(ord(character_axis) + i) + str(number_axis + i)) in white_pieces:
                    break
                elif pieces.get(chr(ord(character_axis) + i) + str(number_axis + i)) in black_pieces:
                    valid_locations.append(chr(ord(character_axis) + i) + str(number_axis + i))
                    break
                valid_locations.append(chr(ord(character_axis) + i) + str(number_axis + i))
            for i in range(1, 8): #2
                if pieces.get(chr(ord(character_axis) + i) + str(number_axis - i)) in white_pieces:
                    break
                elif pieces.get(chr(ord(character_axis) + i) + str(number_axis - i)) in black_pieces:
                    valid_locations.append(chr(ord(character_axis) + i) + str(number_axis - i))
                    break
                valid_locations.append(chr(ord(character_axis) + i) + str(number_axis - i))
            for i in range(1, 8): #3
                if pieces.get(chr(ord(character_axis) - i) + str(number_axis + i)) in white_pieces:
                    break
                elif pieces.get(chr(ord(character_axis) - i) + str(number_axis + i)) in black_pieces:
                    valid_locations.append(chr(ord(character_axis) - i) + str(number_axis + i))
                    break
                valid_locations.append(chr(ord(character_axis) + i) + str(number_axis - i))
            for i in range(1, 8): #4
                if pieces.get(chr(ord(character_axis) - i) + str(number_axis - i)) in white_pieces:
                    break
                elif pieces.get(chr(ord(character_axis) - i) + str(number_axis - i)) in black_pieces:
                    valid_locations.append(chr(ord(character_axis) - i) + str(number_axis - i))
                    break
                valid_locations.append(chr(ord(character_axis) + i) + str(number_axis - i))
            for i in range(len(valid_locations)):
                if list(valid_locations[i])[0] not in alphabet or str(list(valid_locations[i])[1]) not in number_list or len(valid_locations[i]) > 2:
                    locations_to_remove.append(valid_locations[i])
            for i in range(len(locations_to_remove)):
                if locations_to_remove[i] in valid_locations:
                    valid_locations.remove(locations_to_remove[i])
        elif pieces.get(to_move) == W_queen: # queens's code
            piece = "Queen"
            full_piece_name = piece + " " + to_move
            for i in range(1, 8):
                if pieces.get(str((chr(ord(character_axis) + i)) + str(number_axis))) in white_pieces:
                    break
                elif pieces.get(str((chr(ord(character_axis) + i)) + str(number_axis))) in black_pieces:
                    valid_locations.append(str((chr(ord(character_axis) + i)) + str(number_axis)))
                    break
                valid_locations.append(str((chr(ord(character_axis) + i)) + str(number_axis)))
            for i in range(1, 8):
                if pieces.get(str((chr(ord(character_axis) - i)) + str(number_axis))) in white_pieces:
                    break
                elif pieces.get(str((chr(ord(character_axis) - i)) + str(number_axis))) in black_pieces:
                    valid_locations.append(str((chr(ord(character_axis) - i)) + str(number_axis)))
                    break
                valid_locations.append(str((chr(ord(character_axis) - i)) + str(number_axis)))
            for i in range(1, 8):
                if pieces.get(character_axis + str(int(number_axis) + i)) in white_pieces:
                    break
                elif pieces.get(character_axis + str(int(number_axis) + i)) in black_pieces:
                    valid_locations.append(str((chr(ord(character_axis) + i)) + str(number_axis)))
                    break
                valid_locations.append(character_axis + str(int(number_axis) + i))
            for i in range(1, 8):
                if pieces.get(character_axis + str(int(number_axis) - i)) in white_pieces:
                    break
                elif pieces.get(character_axis + str(int(number_axis) - i)) in black_pieces:
                    valid_locations.append(str((chr(ord(character_axis) - i)) + str(number_axis)))
                    break
                valid_locations.append(character_axis + str(int(number_axis) - i))
            for i in range(1, 8): #1
                if pieces.get(chr(ord(character_axis) + i) + str(number_axis + i)) in white_pieces:
                    break
                elif pieces.get(chr(ord(character_axis) + i) + str(number_axis + i)) in black_pieces:
                    valid_locations.append(chr(ord(character_axis) + i) + str(number_axis + i))
                    break
                valid_locations.append(chr(ord(character_axis) + i) + str(number_axis + i))
            for i in range(1, 8): #2
                if pieces.get(chr(ord(character_axis) + i) + str(number_axis - i)) in white_pieces:
                    break
                elif pieces.get(chr(ord(character_axis) + i) + str(number_axis - i)) in black_pieces:
                    valid_locations.append(chr(ord(character_axis) + i) + str(number_axis - i))
                    break
                valid_locations.append(chr(ord(character_axis) + i) + str(number_axis - i))
            for i in range(1, 8): #3
                if pieces.get(chr(ord(character_axis) - i) + str(number_axis + i)) in white_pieces:
                    break
                elif pieces.get(chr(ord(character_axis) - i) + str(number_axis + i)) in black_pieces:
                    valid_locations.append(chr(ord(character_axis) - i) + str(number_axis + i))
                    break
                valid_locations.append(chr(ord(character_axis) - i) + str(number_axis + i))
            for i in range(1, 8): #4
                if pieces.get(chr(ord(character_axis) - i) + str(number_axis - i)) in white_pieces:
                    break
                elif pieces.get(chr(ord(character_axis) - i) + str(number_axis - i)) in black_pieces:
                    valid_locations.append(chr(ord(character_axis) - i) + str(number_axis - i))
                    break
                valid_locations.append(chr(ord(character_axis) - i) + str(number_axis - i))
            for i in range(len(valid_locations)):
                if list(valid_locations[i])[0] not in alphabet or str(list(valid_locations[i])[1]) not in number_list or len(valid_locations[i]) > 2:
                    locations_to_remove.append(valid_locations[i])
            if list(valid_locations[i])[0] not in alphabet or str(list(valid_locations[i])[1]) not in number_list or len(valid_locations[i]) > 2:
                    locations_to_remove.append(valid_locations[i])
            for i in range(len(locations_to_remove)):
                if locations_to_remove[i] in valid_locations:
                    valid_locations.remove(locations_to_remove[i])
        elif pieces.get(to_move) == W_pawn: # pawn's code
            piece = "Pawn" 
            full_piece_name = piece + " " + to_move
            valid_locations.append(chr(ord(character_axis) + 1) + str(number_axis + 1))
            valid_locations.append(chr(ord(character_axis) + 1) + str(number_axis - 1))
        elif pieces.get(to_move) == W_king: # king's code
            piece = "King" 
            full_piece_name = piece + " " + to_move
            for i in range(1, 2): # recycled queen code but for 1 square in all directions
                if pieces.get(str((chr(ord(character_axis) + i)) + str(number_axis))) in white_pieces:
                    break
                elif pieces.get(str((chr(ord(character_axis) + i)) + str(number_axis))) in black_pieces:
                    valid_locations.append(str((chr(ord(character_axis) + i)) + str(number_axis)))
                    break
                valid_locations.append(str((chr(ord(character_axis) + i)) + str(number_axis)))
            for i in range(1, 2):
                if pieces.get(str((chr(ord(character_axis) - i)) + str(number_axis))) in white_pieces:
                    break
                elif pieces.get(str((chr(ord(character_axis) - i)) + str(number_axis))) in black_pieces:
                    valid_locations.append(str((chr(ord(character_axis) - i)) + str(number_axis)))
                    break
                valid_locations.append(str((chr(ord(character_axis) - i)) + str(number_axis)))
            for i in range(1, 2):
                if pieces.get(character_axis + str(int(number_axis) + i)) in white_pieces:
                    break
                elif pieces.get(character_axis + str(int(number_axis) + i)) in black_pieces:
                    valid_locations.append(str((chr(ord(character_axis) + i)) + str(number_axis)))
                    break
                valid_locations.append(character_axis + str(int(number_axis) + i))
            for i in range(1, 2):
                if pieces.get(character_axis + str(int(number_axis) - i)) in white_pieces:
                    break
                elif pieces.get(character_axis + str(int(number_axis) - i)) in black_pieces:
                    valid_locations.append(str((chr(ord(character_axis) - i)) + str(number_axis)))
                    break
                valid_locations.append(character_axis + str(int(number_axis) - i))
            for i in range(1, 2): #1
                if pieces.get(chr(ord(character_axis) + i) + str(number_axis + i)) in white_pieces:
                    break
                elif pieces.get(chr(ord(character_axis) + i) + str(number_axis + i)) in black_pieces:
                    valid_locations.append(chr(ord(character_axis) + i) + str(number_axis + i))
                    break
                valid_locations.append(chr(ord(character_axis) + i) + str(number_axis + i))
            for i in range(1, 2): #2
                if pieces.get(chr(ord(character_axis) + i) + str(number_axis - i)) in white_pieces:
                    break
                elif pieces.get(chr(ord(character_axis) + i) + str(number_axis - i)) in black_pieces:
                    valid_locations.append(chr(ord(character_axis) + i) + str(number_axis - i))
                    break
                valid_locations.append(chr(ord(character_axis) + i) + str(number_axis - i))
            for i in range(1, 2): #3
                if pieces.get(chr(ord(character_axis) - i) + str(number_axis + i)) in white_pieces:
                    break
                elif pieces.get(chr(ord(character_axis) - i) + str(number_axis + i)) in black_pieces:
                    valid_locations.append(chr(ord(character_axis) - i) + str(number_axis + i))
                    break
                valid_locations.append(chr(ord(character_axis) + i) + str(number_axis - i))
            for i in range(1, 2): #4
                if pieces.get(chr(ord(character_axis) - i) + str(number_axis - i)) in white_pieces:
                    break
                elif pieces.get(chr(ord(character_axis) - i) + str(number_axis - i)) in black_pieces:
                    valid_locations.append(chr(ord(character_axis) - i) + str(number_axis - i))
                    break
                valid_locations.append(chr(ord(character_axis) + i) + str(number_axis - i))
            for i in range(len(valid_locations)):
                if list(valid_locations[i])[0] not in alphabet or str(list(valid_locations[i])[1]) not in number_list or len(valid_locations[i]) > 2:
                    locations_to_remove.append(valid_locations[i])
            for i in range(len(locations_to_remove)):
                if locations_to_remove[i] in valid_locations:
                    valid_locations.remove(locations_to_remove[i])
    kill_zones = list(dict.fromkeys(valid_locations))
print("Format for inputs: a1\nFormat for changing piece: 'back'")
choose_new_piece_black = False
choose_new_piece_white = False
new_location = ""
def playable_board_finder():
    global playable_board
    playable_board = []
    for k in range(8):
        for i in range(8):
            playable_board.append(pieces.get(alphabet[k] + str(i + 1)))
while True:
    if choose_new_piece_black == False:
        player_turn = "white"
        get_board()
        playable_board_finder()
        if W_king in playable_board:
            print(f"{colour}White's turn:{Fore.WHITE}")
            print(visual_board)
            check_checker_white()
            if W_king_location in kill_zones:
                print(f"{Fore.MAGENTA}Check for: {Fore.CYAN}White's King{Fore.WHITE}")
            while True:
                to_move = input("Piece to move: ")
                if pieces.get(to_move) in white_pieces:
                    print("Valid piece")
                    break
                elif new_location == "back":
                    choose_new_piece_white = True
                    break
                else:
                    print("Invalid piece")
            valid_locations = []
            character_axis = list(to_move)[0]
            number_axis = int(list(to_move)[1])
            locations_to_remove = []
            if pieces.get(to_move) == W_rook: # rook's code
                piece = "Rook"
                full_piece_name = piece + " " + to_move
                number_axis = str(number_axis)
                for i in range(1, 8):
                    if pieces.get(str((chr(ord(character_axis) + i)) + str(number_axis))) in white_pieces:
                        break
                    elif pieces.get(str((chr(ord(character_axis) + i)) + str(number_axis))) in black_pieces:
                        valid_locations.append(str((chr(ord(character_axis) + i)) + str(number_axis)))
                        break
                    valid_locations.append(str((chr(ord(character_axis) + i)) + str(number_axis)))
                for i in range(1, 8):
                    if pieces.get(str((chr(ord(character_axis) - i)) + str(number_axis))) in white_pieces:
                        break
                    elif pieces.get(str((chr(ord(character_axis) - i)) + str(number_axis))) in black_pieces:
                        valid_locations.append(str((chr(ord(character_axis) - i)) + str(number_axis)))
                        break
                    valid_locations.append(str((chr(ord(character_axis) - i)) + str(number_axis)))
                for i in range(1, 8):
                    if pieces.get(character_axis + str(int(number_axis) + i)) in white_pieces:
                        break
                    elif pieces.get(character_axis + str(int(number_axis) + i)) in black_pieces:
                        valid_locations.append(str((chr(ord(character_axis) + i)) + str(number_axis)))
                        break
                    valid_locations.append(character_axis + str(int(number_axis) + i))
                for i in range(1, 8):
                    if pieces.get(character_axis + str(int(number_axis) - i)) in white_pieces:
                        break
                    elif pieces.get(character_axis + str(int(number_axis) - i)) in black_pieces:
                        valid_locations.append(str((chr(ord(character_axis) - i)) + str(number_axis)))
                        break
                    valid_locations.append(character_axis + str(int(number_axis) - i))
                for i in range(len(valid_locations)):
                    if list(valid_locations[i])[0] not in alphabet or list(valid_locations[i])[1] not in number_list or len(valid_locations[i]) > 2 or pieces.get(valid_locations[i]) in white_pieces:
                        locations_to_remove.append(valid_locations[i])
                for i in range(len(locations_to_remove)):
                    if locations_to_remove[i] in valid_locations:
                        valid_locations.remove(locations_to_remove[i])
                print("Valid locations where you can move;", full_piece_name + ":\n" + str(valid_locations))
                if len(valid_locations) == 0:
                    print("Choose another piece")
                    choose_new_piece_white = True
                else:
                    choose_new_piece_white = False
                    while True:
                        new_location = input("Where to move " + full_piece_name + "?: ")
                        if new_location in valid_locations:
                            print("Valid move")
                            pieces[new_location] = W_rook
                            if to_move in black_tiles:
                               pieces[to_move] = black_square
                            else:
                                pieces[to_move] = white_square
                            break
                        elif new_location == "back":
                            choose_new_piece_white = True
                            break
                        else:
                            print("Invalid move")
            elif pieces.get(to_move) == W_knight: # knight's code
                piece = "Knight"
                full_piece_name = piece + " " + to_move
                valid_locations.append(chr(ord(character_axis) - 2) + str(number_axis - 1)) #1
                valid_locations.append(chr(ord(character_axis) - 2) + str(number_axis + 1)) #2
                valid_locations.append(chr(ord(character_axis) - 1) + str(number_axis + 2)) #3
                valid_locations.append(chr(ord(character_axis) + 1) + str(number_axis + 2)) #4
                valid_locations.append(chr(ord(character_axis) + 2) + str(number_axis + 1)) #5
                valid_locations.append(chr(ord(character_axis) + 2) + str(number_axis - 1)) #6
                valid_locations.append(chr(ord(character_axis) + 1) + str(number_axis - 2)) #7
                valid_locations.append(chr(ord(character_axis) - 1) + str(number_axis - 2)) #8
                for i in range(len(valid_locations)):
                    if list(valid_locations[i])[0] not in alphabet or str(list(valid_locations[i])[1]) not in number_list or pieces.get(valid_locations[i]) in white_pieces or len(valid_locations[i]) > 2:
                        locations_to_remove.append(valid_locations[i])
                for i in range(len(locations_to_remove)):
                    if locations_to_remove[i] in valid_locations:
                        valid_locations.remove(locations_to_remove[i])
                print("Valid locations where you can move;", full_piece_name + ":\n" + str(valid_locations))
                if len(valid_locations) == 0:
                    print("Choose another piece")
                    choose_new_piece_white = True
                else:
                    choose_new_piece_white = False
                    while True:
                        new_location = input("Where to move " + full_piece_name + "?: ")
                        if new_location in valid_locations:
                            print("Valid move")
                            pieces[new_location] = W_knight
                            if to_move in black_tiles:
                               pieces[to_move] = black_square
                            else:
                                pieces[to_move] = white_square
                            break
                        elif new_location == "back":
                            choose_new_piece_white = True
                            break
                        else:
                            print("Invalid move")
            elif pieces.get(to_move) == W_bishop: # bishop's code
                piece = "Bishop"
                full_piece_name = piece + " " + to_move
                for i in range(1, 8): #1
                    if pieces.get(chr(ord(character_axis) + i) + str(number_axis + i)) in white_pieces:
                        break
                    elif pieces.get(chr(ord(character_axis) + i) + str(number_axis + i)) in black_pieces:
                        valid_locations.append(chr(ord(character_axis) + i) + str(number_axis + i))
                        break
                    valid_locations.append(chr(ord(character_axis) + i) + str(number_axis + i))
                for i in range(1, 8): #2
                    if pieces.get(chr(ord(character_axis) + i) + str(number_axis - i)) in white_pieces:
                        break
                    elif pieces.get(chr(ord(character_axis) + i) + str(number_axis - i)) in black_pieces:
                        valid_locations.append(chr(ord(character_axis) + i) + str(number_axis - i))
                        break
                    valid_locations.append(chr(ord(character_axis) + i) + str(number_axis - i))
                for i in range(1, 8): #3
                    if pieces.get(chr(ord(character_axis) - i) + str(number_axis + i)) in white_pieces:
                        break
                    elif pieces.get(chr(ord(character_axis) - i) + str(number_axis + i)) in black_pieces:
                        valid_locations.append(chr(ord(character_axis) - i) + str(number_axis + i))
                        break
                valid_locations.append(chr(ord(character_axis) - i) + str(number_axis + i))
                for i in range(1, 8): #4
                    if pieces.get(chr(ord(character_axis) - i) + str(number_axis - i)) in white_pieces:
                        break
                    elif pieces.get(chr(ord(character_axis) - i) + str(number_axis - i)) in black_pieces:
                        locations_to_remove.append(chr(ord(character_axis) - i) + str(number_axis - i))
                        break
                locations_to_remove.append(chr(ord(character_axis) - i) + str(number_axis - i))
                for i in range(len(valid_locations)):
                    if list(valid_locations[i])[0] not in alphabet or str(list(valid_locations[i])[1]) not in number_list or len(valid_locations[i]) > 2:
                        locations_to_remove.append(valid_locations[i])
                for i in range(len(locations_to_remove)):
                    if locations_to_remove[i] in valid_locations:
                        valid_locations.remove(locations_to_remove[i])
                print("Valid locations where you can move;", full_piece_name + ":\n" + str(valid_locations))
                if len(valid_locations) == 0:
                    print("Choose another piece")
                    choose_new_piece_white = True
                else:
                    choose_new_piece_white = False
                    while True:
                        new_location = input("Where to move " + full_piece_name + "?: ")
                        if new_location in valid_locations:
                            print("Valid move")
                            pieces[new_location] = W_bishop
                            if to_move in black_tiles:
                               pieces[to_move] = black_square
                            else:
                                pieces[to_move] = white_square
                            break
                        elif new_location == "back":
                            choose_new_piece_white = True
                            break
                        else:
                            print("Invalid move")
            elif pieces.get(to_move) == W_queen: # queens's code
                piece = "Queen"
                full_piece_name = piece + " " + to_move
                for i in range(1, 8):
                    if pieces.get(str((chr(ord(character_axis) + i)) + str(number_axis))) in white_pieces:
                        break
                    elif pieces.get(str((chr(ord(character_axis) + i)) + str(number_axis))) in black_pieces:
                        valid_locations.append(str((chr(ord(character_axis) + i)) + str(number_axis)))
                        break
                    valid_locations.append(str((chr(ord(character_axis) + i)) + str(number_axis)))
                for i in range(1, 8):
                    if pieces.get(str((chr(ord(character_axis) - i)) + str(number_axis))) in white_pieces:
                        break
                    elif pieces.get(str((chr(ord(character_axis) - i)) + str(number_axis))) in black_pieces:
                        valid_locations.append(str((chr(ord(character_axis) - i)) + str(number_axis)))
                        break
                    valid_locations.append(str((chr(ord(character_axis) - i)) + str(number_axis)))
                for i in range(1, 8):
                    if pieces.get(character_axis + str(int(number_axis) + i)) in white_pieces:
                        break
                    elif pieces.get(character_axis + str(int(number_axis) + i)) in black_pieces:
                        valid_locations.append(str((chr(ord(character_axis) + i)) + str(number_axis)))
                        break
                    valid_locations.append(character_axis + str(int(number_axis) + i))
                for i in range(1, 8):
                    if pieces.get(character_axis + str(int(number_axis) - i)) in white_pieces:
                        break
                    elif pieces.get(character_axis + str(int(number_axis) - i)) in black_pieces:
                        valid_locations.append(str((chr(ord(character_axis) - i)) + str(number_axis)))
                        break
                    valid_locations.append(character_axis + str(int(number_axis) - i))
                for i in range(1, 8): #1
                    if pieces.get(chr(ord(character_axis) + i) + str(number_axis + i)) in white_pieces:
                        break
                    elif pieces.get(chr(ord(character_axis) + i) + str(number_axis + i)) in black_pieces:
                        valid_locations.append(chr(ord(character_axis) + i) + str(number_axis + i))
                        break
                    valid_locations.append(chr(ord(character_axis) + i) + str(number_axis + i))
                for i in range(1, 8): #2
                    if pieces.get(chr(ord(character_axis) + i) + str(number_axis - i)) in white_pieces:
                        break
                    elif pieces.get(chr(ord(character_axis) + i) + str(number_axis - i)) in black_pieces:
                        valid_locations.append(chr(ord(character_axis) + i) + str(number_axis - i))
                        break
                    valid_locations.append(chr(ord(character_axis) + i) + str(number_axis - i))
                for i in range(1, 8): #3
                    if pieces.get(chr(ord(character_axis) - i) + str(number_axis + i)) in white_pieces:
                        break
                    elif pieces.get(chr(ord(character_axis) - i) + str(number_axis + i)) in black_pieces:
                        valid_locations.append(chr(ord(character_axis) - i) + str(number_axis + i))
                        break
                    valid_locations.append(chr(ord(character_axis) - i) + str(number_axis + i))
                valid_locations.append(chr(ord(character_axis) - i) + str(number_axis + i))
                for i in range(1, 8): #4
                    if pieces.get(chr(ord(character_axis) - i) + str(number_axis - i)) in white_pieces:
                        break
                    elif pieces.get(chr(ord(character_axis) - i) + str(number_axis - i)) in black_pieces:
                        valid_locations.append(chr(ord(character_axis) - i) + str(number_axis - i))
                        break
                    valid_locations.append(chr(ord(character_axis) - i) + str(number_axis - i))
                for i in range(len(valid_locations)):
                    if list(valid_locations[i])[0] not in alphabet or str(list(valid_locations[i])[1]) not in number_list or len(valid_locations[i]) > 2 or pieces.get(valid_locations[i]) in white_pieces:
                        locations_to_remove.append(valid_locations[i])
                for i in range(len(locations_to_remove)):
                    if locations_to_remove[i] in valid_locations:
                        valid_locations.remove(locations_to_remove[i])
                print("Valid locations where you can move;", full_piece_name + ":\n" + str(valid_locations))
                if len(valid_locations) == 0:
                    print("Choose another piece")
                    choose_new_piece_white = True
                else:
                    choose_new_piece_white = False
                    while True:
                        new_location = input("Where to move " + full_piece_name + "?: ")
                        if new_location in valid_locations:
                            print("Valid move")
                            pieces[new_location] = W_queen
                            if to_move in black_tiles:
                               pieces[to_move] = black_square
                            else:
                                pieces[to_move] = white_square
                            break
                        elif new_location == "back":
                            choose_new_piece_white = True
                            break
                        else:
                            print("Invalid move")
            elif pieces.get(to_move) == W_pawn: # pawn's code
                piece = "Pawn" 
                full_piece_name = piece + " " + to_move
                if list(to_move)[0] == "b":
                    valid_locations.append(chr(ord(character_axis) + 2) + str(number_axis))
                valid_locations.append(chr(ord(character_axis) + 1) + str(number_axis))
                for i in range(len(valid_locations)):
                    if pieces.get(valid_locations[i]) in white_pieces or pieces.get(valid_locations[i]) in black_pieces or list(valid_locations[i])[0] not in alphabet or list(valid_locations[i])[1] not in number_list:
                        locations_to_remove.append(valid_locations[i])
                        if valid_locations[i] == chr(ord(character_axis) + 1) + str(number_axis):
                            locations_to_remove.append(chr(ord(character_axis) + 2) + str(number_axis))
                    for i in range(len(locations_to_remove)):
                        if locations_to_remove[i] in valid_locations:
                            valid_locations.remove(locations_to_remove[i])
                if pieces.get(chr(ord(character_axis) + 1) + str(number_axis + 1)) in black_pieces: # diagonal attacks for pawn after removing invalid moves
                    valid_locations.append(chr(ord(character_axis) + 1) + str(number_axis + 1))
                if pieces.get(chr(ord(character_axis) + 1) + str(number_axis - 1)) in black_pieces:
                    valid_locations.append(chr(ord(character_axis) + 1) + str(number_axis - 1))
                print("Valid locations where you can move;", full_piece_name + ":\n" + str(valid_locations))
                if len(valid_locations) == 0:
                    print("Choose another piece")
                    choose_new_piece_white = True
                else:
                    choose_new_piece_white = False
                    while True:
                        new_location = input("Where to move " + full_piece_name + "?: ")
                        if new_location in valid_locations:
                            print("Valid move")
                            if list(new_location)[0] == "h":
                                while True:
                                    promotion = input("What would you like to promote your pawn to?; R, B, N, Q: ")
                                    promotion = promotion.upper()
                                    if promotion == "R":
                                        pieces[new_location] = W_rook
                                        W_pawn_count -= 1
                                        total_W_rook_count += 1
                                        break
                                    elif promotion == "B":
                                        pieces[new_location] = W_bishop
                                        total_W_bishop_count += 1
                                        break
                                    elif promotion == "N":
                                        pieces[new_location] = W_knight
                                        total_W_knight_count += 1
                                        break
                                    elif promotion == "Q":
                                        pieces[new_location] = W_queen
                                        total_W_queen_count += 1
                                        break
                                    else:
                                        print("Invalid promotion")
                                total_W_pawn_count -= 1
                            else:
                                pieces[new_location] = W_pawn
                            if to_move in black_tiles:
                                pieces[to_move] = black_square
                            else:
                                pieces[to_move] = white_square
                            break
                        elif new_location == "back":
                            choose_new_piece_white = True
                            break
                        else:
                            print("Invalid move")
            elif pieces.get(to_move) == W_king: # king's code
                piece = "King" 
                full_piece_name = piece + " " + to_move
                for i in range(1, 2): # recycled queen code but for 1 square in all directions
                    if pieces.get(str((chr(ord(character_axis) + i)) + str(number_axis))) in white_pieces:
                        break
                    elif pieces.get(str((chr(ord(character_axis) + i)) + str(number_axis))) in black_pieces:
                        valid_locations.append(str((chr(ord(character_axis) + i)) + str(number_axis)))
                        break
                    valid_locations.append(str((chr(ord(character_axis) + i)) + str(number_axis)))
                for i in range(1, 2):
                    if pieces.get(str((chr(ord(character_axis) - i)) + str(number_axis))) in white_pieces:
                        break
                    elif pieces.get(str((chr(ord(character_axis) - i)) + str(number_axis))) in black_pieces:
                        valid_locations.append(str((chr(ord(character_axis) - i)) + str(number_axis)))
                        break
                    valid_locations.append(str((chr(ord(character_axis) - i)) + str(number_axis)))
                for i in range(1, 2):
                    if pieces.get(character_axis + str(int(number_axis) + i)) in white_pieces:
                        break
                    elif pieces.get(character_axis + str(int(number_axis) + i)) in black_pieces:
                        valid_locations.append(str((chr(ord(character_axis) + i)) + str(number_axis)))
                        break
                    valid_locations.append(character_axis + str(int(number_axis) + i))
                for i in range(1, 2):
                    if pieces.get(character_axis + str(int(number_axis) - i)) in white_pieces:
                        break
                    elif pieces.get(character_axis + str(int(number_axis) - i)) in black_pieces:
                        valid_locations.append(str((chr(ord(character_axis) - i)) + str(number_axis)))
                        break
                    valid_locations.append(character_axis + str(int(number_axis) - i))
                for i in range(1, 2): #1
                    if pieces.get(chr(ord(character_axis) + i) + str(number_axis + i)) in white_pieces:
                        break
                    elif pieces.get(chr(ord(character_axis) + i) + str(number_axis + i)) in black_pieces:
                        valid_locations.append(chr(ord(character_axis) + i) + str(number_axis + i))
                        break
                    valid_locations.append(chr(ord(character_axis) + i) + str(number_axis + i))
                for i in range(1, 2): #2
                    if pieces.get(chr(ord(character_axis) + i) + str(number_axis - i)) in white_pieces:
                        break
                    elif pieces.get(chr(ord(character_axis) + i) + str(number_axis - i)) in black_pieces:
                        valid_locations.append(chr(ord(character_axis) + i) + str(number_axis - i))
                        break
                    valid_locations.append(chr(ord(character_axis) + i) + str(number_axis - i))
                for i in range(1, 2): #3
                    if pieces.get(chr(ord(character_axis) - i) + str(number_axis + i)) in white_pieces:
                        break
                    elif pieces.get(chr(ord(character_axis) - i) + str(number_axis + i)) in black_pieces:
                        valid_locations.append(chr(ord(character_axis) - i) + str(number_axis + i))
                        break
                for i in range(1, 2): #4
                    if pieces.get(chr(ord(character_axis) - i) + str(number_axis - i)) in white_pieces:
                        break
                    elif pieces.get(chr(ord(character_axis) - i) + str(number_axis - i)) in black_pieces:
                        valid_locations.append(chr(ord(character_axis) - i) + str(number_axis - i))
                        break
                for i in range(len(valid_locations)):
                    if list(valid_locations[i])[0] not in alphabet or str(list(valid_locations[i])[1]) not in number_list or len(valid_locations[i]) > 2:
                        locations_to_remove.append(valid_locations[i])
                for i in range(len(locations_to_remove)):
                    if locations_to_remove[i] in valid_locations:
                        valid_locations.remove(locations_to_remove[i])
                print("Valid locations where you can move;", full_piece_name + ":\n" + str(valid_locations))
                if len(valid_locations) == 0:
                    print("Choose another piece")
                    choose_new_piece_white = True
                else:
                    choose_new_piece_white = False
                    while True:
                        new_location = input("Where to move " + full_piece_name + "?: ")
                        if new_location in valid_locations:
                            print("Valid move")
                            pieces[new_location] = W_king
                            W_king_location = new_location
                            if to_move in black_tiles:
                               pieces[to_move] = black_square
                            else:
                                pieces[to_move] = white_square
                            break
                        elif new_location == "back":
                            choose_new_piece_black = True
                            break
                        else:
                            print("Invalid move")
        else:
            print("White king is dead: Black wins!")
            king_dead = True
            break
    if choose_new_piece_white == False:
        player_turn = "black"
        get_board()
        playable_board_finder()
        if B_king in playable_board:
            print(f"{colour}Black's turn:{Fore.WHITE}")
            print(visual_board)
            check_checker_black()
            if W_king_location in kill_zones:
                print(f"{Fore.MAGENTA}Check for: {Fore.RED}Black's King{Fore.WHITE}")
            while True:
                to_move = input("Piece to move: ")
                if pieces.get(to_move) in black_pieces:
                    print("Valid piece")
                    break
                elif new_location == "back":
                    choose_new_piece_black = True
                    break
                else:
                    print("Invalid piece")
            valid_locations = []
            character_axis = list(to_move)[0]
            number_axis = int(list(to_move)[1])
            locations_to_remove = []
            if pieces.get(to_move) == B_rook: # rook's code
                piece = "Rook"
                full_piece_name = piece + " " + to_move
                number_axis = str(number_axis)
                for i in range(1, 8):
                    if pieces.get(str((chr(ord(character_axis) + i)) + str(number_axis))) in black_pieces:
                        break
                    elif pieces.get(str((chr(ord(character_axis) + i)) + str(number_axis))) in white_pieces:
                        valid_locations.append(str((chr(ord(character_axis) + i)) + str(number_axis)))
                        break
                    valid_locations.append(str((chr(ord(character_axis) + i)) + str(number_axis)))
                for i in range(1, 8):
                    if pieces.get(str((chr(ord(character_axis) - i)) + str(number_axis))) in black_pieces:
                        break
                    elif pieces.get(str((chr(ord(character_axis) - i)) + str(number_axis))) in white_pieces:
                        valid_locations.append(str((chr(ord(character_axis) - i)) + str(number_axis)))
                        break
                    valid_locations.append(str((chr(ord(character_axis) - i)) + str(number_axis)))
                for i in range(1, 8):
                    if pieces.get(character_axis + str(int(number_axis) + i)) in black_pieces:
                        break
                    elif pieces.get(character_axis + str(int(number_axis) + i)) in white_pieces:
                        valid_locations.append(str((chr(ord(character_axis) + i)) + str(number_axis)))
                        break
                    valid_locations.append(character_axis + str(int(number_axis) + i))
                for i in range(1, 8):
                    if pieces.get(character_axis + str(int(number_axis) - i)) in black_pieces:
                        break
                    elif pieces.get(character_axis + str(int(number_axis) - i)) in white_pieces:
                        valid_locations.append(str((chr(ord(character_axis) - i)) + str(number_axis)))
                        break
                    valid_locations.append(character_axis + str(int(number_axis) - i))
                for i in range(len(valid_locations)):
                    if list(valid_locations[i])[0] not in alphabet or list(valid_locations[i])[1] not in number_list or len(valid_locations[i]) > 2:
                        locations_to_remove.append(valid_locations[i])
                    if pieces.get(valid_locations[i]) in black_pieces:
                        locations_to_remove.append(valid_locations[i])
                for i in range(len(locations_to_remove)):
                    if locations_to_remove[i] in valid_locations:
                        valid_locations.remove(locations_to_remove[i])
                print("Valid locations where you can move;", full_piece_name + ":\n" + str(valid_locations))
                if len(valid_locations) == 0:
                    print("Choose another piece")
                    choose_new_piece_black = True
                else:
                    choose_new_piece_black = False
                    while True:
                        new_location = input("Where to move " + full_piece_name + "?: ")
                        if new_location in valid_locations:
                            print("Valid move")
                            pieces[new_location] = B_rook
                            if to_move in black_tiles:
                               pieces[to_move] = black_square
                            else:
                                pieces[to_move] = white_square
                            break
                        elif new_location == "back":
                            choose_new_piece_black = True
                            break
                        else:
                            print("Invalid move")
            elif pieces.get(to_move) == B_knight: # knight's code
                piece = "Knight"
                full_piece_name = piece + " " + to_move
                valid_locations.append(chr(ord(character_axis) - 2) + str(number_axis - 1)) #1
                valid_locations.append(chr(ord(character_axis) - 2) + str(number_axis + 1)) #2
                valid_locations.append(chr(ord(character_axis) - 1) + str(number_axis + 2)) #3
                valid_locations.append(chr(ord(character_axis) + 1) + str(number_axis + 2)) #4
                valid_locations.append(chr(ord(character_axis) + 2) + str(number_axis + 1)) #5
                valid_locations.append(chr(ord(character_axis) + 2) + str(number_axis - 1)) #6
                valid_locations.append(chr(ord(character_axis) + 1) + str(number_axis - 2)) #7
                valid_locations.append(chr(ord(character_axis) - 1) + str(number_axis - 2)) #8
                for i in range(len(valid_locations)):
                    if list(valid_locations[i])[0] not in alphabet or str(list(valid_locations[i])[1]) not in number_list or pieces.get(valid_locations[i]) in black_pieces or len(valid_locations[i]) > 2:
                        locations_to_remove.append(valid_locations[i])
                for i in range(len(locations_to_remove)):
                    if locations_to_remove[i] in valid_locations:
                        valid_locations.remove(locations_to_remove[i])
                print("Valid locations where you can move;", full_piece_name + ":\n" + str(valid_locations))
                if len(valid_locations) == 0:
                    print("Choose another piece")
                    choose_new_piece_black = True
                else:
                    choose_new_piece_black = False
                    while True:
                        new_location = input("Where to move " + full_piece_name + "?: ")
                        if new_location in valid_locations:
                            print("Valid move")
                            pieces[new_location] = B_knight
                            if to_move in black_tiles:
                               pieces[to_move] = black_square
                            else:
                                pieces[to_move] = white_square
                            break
                        elif new_location == "back":
                            choose_new_piece_black = True
                            break
                        else:
                            print("Invalid move")
            elif pieces.get(to_move) == B_bishop: # bishop's code
                piece = "Bishop"
                full_piece_name = piece + " " + to_move
                for i in range(1, 8): #1
                    if pieces.get(chr(ord(character_axis) + i) + str(number_axis + i)) in black_pieces:
                        break
                    elif pieces.get(chr(ord(character_axis) + i) + str(number_axis + i)) in white_pieces:
                        valid_locations.append(chr(ord(character_axis) + i) + str(number_axis + i))
                        break
                    valid_locations.append(chr(ord(character_axis) + i) + str(number_axis + i))
                for i in range(1, 8): #2
                    if pieces.get(chr(ord(character_axis) + i) + str(number_axis - i)) in black_pieces:
                        break
                    elif pieces.get(chr(ord(character_axis) + i) + str(number_axis - i)) in white_pieces:
                        valid_locations.append(chr(ord(character_axis) + i) + str(number_axis - i))
                        break
                    valid_locations.append(chr(ord(character_axis) + i) + str(number_axis - i))
                for i in range(1, 8): #3
                    if pieces.get(chr(ord(character_axis) - i) + str(number_axis + i)) in black_pieces:
                        break
                    elif pieces.get(chr(ord(character_axis) - i) + str(number_axis + i)) in white_pieces:
                        valid_locations.append(chr(ord(character_axis) - i) + str(number_axis + i))
                        break
                    valid_locations.append(chr(ord(character_axis) + i) + str(number_axis - i))
                for i in range(1, 8): #4
                    if pieces.get(chr(ord(character_axis) - i) + str(number_axis - i)) in black_pieces:
                        break
                    elif pieces.get(chr(ord(character_axis) - i) + str(number_axis - i)) in white_pieces:
                        valid_locations.append(chr(ord(character_axis) - i) + str(number_axis - i))
                        break
                    valid_locations.append(chr(ord(character_axis) + i) + str(number_axis - i))
                for i in range(len(valid_locations)):
                    if list(valid_locations[i])[0] not in alphabet or str(list(valid_locations[i])[1]) not in number_list or len(valid_locations[i]) > 2:
                        locations_to_remove.append(valid_locations[i])
                for i in range(len(locations_to_remove)):
                    if locations_to_remove[i] in valid_locations:
                        valid_locations.remove(locations_to_remove[i])
                print("Valid locations where you can move;", full_piece_name + ":\n" + str(valid_locations))
                if len(valid_locations) == 0:
                    print("Choose another piece")
                    choose_new_piece_black = True
                else:
                    choose_new_piece_black = False
                    while True:
                        new_location = input("Where to move " + full_piece_name + "?: ")
                        if new_location in valid_locations:
                            print("Valid move")
                            pieces[new_location] = B_bishop
                            if to_move in black_tiles:
                               pieces[to_move] = black_square
                            else:
                                pieces[to_move] = white_square
                            break
                        elif new_location == "back":
                            choose_new_piece_black = True
                            break
                        else:
                            print("Invalid move")
            elif pieces.get(to_move) == B_queen: # queens's code
                piece = "Queen"
                full_piece_name = piece + " " + to_move
                for i in range(1, 8):
                    if pieces.get(str((chr(ord(character_axis) + i)) + str(number_axis))) in black_pieces:
                        break
                    elif pieces.get(str((chr(ord(character_axis) + i)) + str(number_axis))) in white_pieces:
                        valid_locations.append(str((chr(ord(character_axis) + i)) + str(number_axis)))
                        break
                    valid_locations.append(str((chr(ord(character_axis) + i)) + str(number_axis)))
                for i in range(1, 8):
                    if pieces.get(str((chr(ord(character_axis) - i)) + str(number_axis))) in black_pieces:
                        break
                    elif pieces.get(str((chr(ord(character_axis) - i)) + str(number_axis))) in white_pieces:
                        valid_locations.append(str((chr(ord(character_axis) - i)) + str(number_axis)))
                        break
                    valid_locations.append(str((chr(ord(character_axis) - i)) + str(number_axis)))
                for i in range(1, 8):
                    if pieces.get(character_axis + str(int(number_axis) + i)) in black_pieces:
                        break
                    elif pieces.get(character_axis + str(int(number_axis) + i)) in white_pieces:
                        valid_locations.append(str((chr(ord(character_axis) + i)) + str(number_axis)))
                        break
                    valid_locations.append(character_axis + str(int(number_axis) + i))
                for i in range(1, 8):
                    if pieces.get(character_axis + str(int(number_axis) - i)) in black_pieces:
                        break
                    elif pieces.get(character_axis + str(int(number_axis) - i)) in white_pieces:
                        valid_locations.append(str((chr(ord(character_axis) - i)) + str(number_axis)))
                        break
                    valid_locations.append(character_axis + str(int(number_axis) - i))
                for i in range(1, 8): #1
                    if pieces.get(chr(ord(character_axis) + i) + str(number_axis + i)) in black_pieces:
                        break
                    elif pieces.get(chr(ord(character_axis) + i) + str(number_axis + i)) in white_pieces:
                        valid_locations.append(chr(ord(character_axis) + i) + str(number_axis + i))
                        break
                    valid_locations.append(chr(ord(character_axis) + i) + str(number_axis + i))
                for i in range(1, 8): #2
                    if pieces.get(chr(ord(character_axis) + i) + str(number_axis - i)) in black_pieces:
                        break
                    elif pieces.get(chr(ord(character_axis) + i) + str(number_axis - i)) in white_pieces:
                        valid_locations.append(chr(ord(character_axis) + i) + str(number_axis - i))
                        break
                    valid_locations.append(chr(ord(character_axis) + i) + str(number_axis - i))
                for i in range(1, 8): #3
                    if pieces.get(chr(ord(character_axis) - i) + str(number_axis + i)) in black_pieces:
                        break
                    elif pieces.get(chr(ord(character_axis) - i) + str(number_axis + i)) in white_pieces:
                        valid_locations.append(chr(ord(character_axis) - i) + str(number_axis + i))
                        break
                    valid_locations.append(chr(ord(character_axis) - i) + str(number_axis + i))
                for i in range(1, 8): #4
                    if pieces.get(chr(ord(character_axis) - i) + str(number_axis - i)) in black_pieces:
                        break
                    elif pieces.get(chr(ord(character_axis) - i) + str(number_axis - i)) in white_pieces:
                        valid_locations.append(chr(ord(character_axis) - i) + str(number_axis - i))
                        break
                    valid_locations.append(chr(ord(character_axis) - i) + str(number_axis - i))
                for i in range(len(valid_locations)):
                    if list(valid_locations[i])[0] not in alphabet or str(list(valid_locations[i])[1]) not in number_list or len(valid_locations[i]) > 2:
                        locations_to_remove.append(valid_locations[i])
                if list(valid_locations[i])[0] not in alphabet or str(list(valid_locations[i])[1]) not in number_list or len(valid_locations[i]) > 2:
                        locations_to_remove.append(valid_locations[i])
                for i in range(len(locations_to_remove)):
                    if locations_to_remove[i] in valid_locations:
                        valid_locations.remove(locations_to_remove[i])
                print("Valid locations where you can move;", full_piece_name + ":\n" + str(valid_locations))
                if len(valid_locations) == 0:
                    print("Choose another piece")
                    choose_new_piece_black = True
                else:
                    choose_new_piece_black = False
                    while True:
                        new_location = input("Where to move " + full_piece_name + "?: ")
                        if new_location in valid_locations:
                            print("Valid move")
                            pieces[new_location] = B_queen
                            if to_move in black_tiles:
                               pieces[to_move] = black_square
                            else:
                                pieces[to_move] = white_square
                            break
                        elif new_location == "back":
                            choose_new_piece_black = True
                            break
                        else:
                            print("Invalid move")
            elif pieces.get(to_move) == B_pawn: # pawn's code
                piece = "Pawn" 
                full_piece_name = piece + " " + to_move
                if list(to_move)[0] == "g":
                    valid_locations.append(chr(ord(character_axis) - 2) + str(number_axis))
                valid_locations.append(chr(ord(character_axis) - 1) + str(number_axis))
                for i in range(len(valid_locations)):
                    if pieces.get(valid_locations[i]) in black_pieces or pieces.get(valid_locations[i]) in white_pieces or list(valid_locations[i])[0] not in alphabet or list(valid_locations[i])[1] not in number_list:
                        locations_to_remove.append(valid_locations[i])
                        if valid_locations[i] == chr(ord(character_axis) - 1) + str(number_axis):
                            locations_to_remove.append(chr(ord(character_axis) - 2) + str(number_axis))
                for i in range(len(locations_to_remove)):
                    if locations_to_remove[i] in valid_locations:
                        valid_locations.remove(locations_to_remove[i])
                if pieces.get(chr(ord(character_axis) - 1) + str(number_axis + 1)) in white_pieces: # diagonal attacks for pawn after removing invalid moves
                    valid_locations.append(chr(ord(character_axis) - 1) + str(number_axis + 1))
                if pieces.get(chr(ord(character_axis) - 1) + str(number_axis - 1)) in white_pieces:
                    valid_locations.append(chr(ord(character_axis) - 1) + str(number_axis - 1))
                print("Valid locations where you can move;", full_piece_name + ":\n" + str(valid_locations))
                if len(valid_locations) == 0:
                    print("Choose another piece")
                    choose_new_piece_black = True
                else:
                    choose_new_piece_black = False
                    while True:
                        new_location = input("Where to move " + full_piece_name + "?: ")
                        if new_location in valid_locations:
                            print("Valid move")
                            if list(new_location)[0] == "a":
                                while True:
                                    promotion = input("What would you like to promote your pawn to?; R, B, N, Q: ")
                                    promotion = promotion.upper()
                                    if promotion == "R":
                                        pieces[new_location] = B_rook
                                        total_B_rook_count += 1
                                        break
                                    elif promotion == "B":
                                        pieces[new_location] = B_bishop
                                        total_B_bishop_count += 1
                                        break
                                    elif promotion == "N":
                                        pieces[new_location] = B_knight
                                        total_B_knight_count += 1
                                        break
                                    elif promotion == "Q":
                                        pieces[new_location] = B_queen
                                        total_B_queen_count += 1
                                        break
                                    else:
                                        print("Invalid promotion")
                                total_B_pawn_count -= 1
                            else:
                                pieces[new_location] = B_pawn
                            if to_move in black_tiles:
                                pieces[to_move] = black_square
                            else:
                                pieces[to_move] = white_square
                            break
                        elif new_location == "back":
                            choose_new_piece_black = True
                            break
                        else:
                            print("Invalid move")
            elif pieces.get(to_move) == B_king: # king's code
                piece = "King" 
                full_piece_name = piece + " " + to_move
                for i in range(1, 2): # recycled queen code but for 1 square in all directions
                    if pieces.get(str((chr(ord(character_axis) + i)) + str(number_axis))) in black_pieces:
                        break
                    elif pieces.get(str((chr(ord(character_axis) + i)) + str(number_axis))) in white_pieces:
                        valid_locations.append(str((chr(ord(character_axis) + i)) + str(number_axis)))
                        break
                    valid_locations.append(str((chr(ord(character_axis) + i)) + str(number_axis)))
                for i in range(1, 2):
                    if pieces.get(str((chr(ord(character_axis) - i)) + str(number_axis))) in black_pieces:
                        break
                    elif pieces.get(str((chr(ord(character_axis) - i)) + str(number_axis))) in white_pieces:
                        valid_locations.append(str((chr(ord(character_axis) - i)) + str(number_axis)))
                        break
                    valid_locations.append(str((chr(ord(character_axis) - i)) + str(number_axis)))
                for i in range(1, 2):
                    if pieces.get(character_axis + str(int(number_axis) + i)) in black_pieces:
                        break
                    elif pieces.get(character_axis + str(int(number_axis) + i)) in white_pieces:
                        valid_locations.append(str((chr(ord(character_axis) + i)) + str(number_axis)))
                        break
                    valid_locations.append(character_axis + str(int(number_axis) + i))
                for i in range(1, 2):
                    if pieces.get(character_axis + str(int(number_axis) - i)) in black_pieces:
                        break
                    elif pieces.get(character_axis + str(int(number_axis) - i)) in white_pieces:
                        valid_locations.append(str((chr(ord(character_axis) - i)) + str(number_axis)))
                        break
                    valid_locations.append(character_axis + str(int(number_axis) - i))
                for i in range(1, 2): #1
                    if pieces.get(chr(ord(character_axis) + i) + str(number_axis + i)) in black_pieces:
                        break
                    elif pieces.get(chr(ord(character_axis) + i) + str(number_axis + i)) in white_pieces:
                        valid_locations.append(chr(ord(character_axis) + i) + str(number_axis + i))
                        break
                    valid_locations.append(chr(ord(character_axis) + i) + str(number_axis + i))
                for i in range(1, 2): #2
                    if pieces.get(chr(ord(character_axis) + i) + str(number_axis - i)) in black_pieces:
                        break
                    elif pieces.get(chr(ord(character_axis) + i) + str(number_axis - i)) in white_pieces:
                        valid_locations.append(chr(ord(character_axis) + i) + str(number_axis - i))
                        break
                    valid_locations.append(chr(ord(character_axis) + i) + str(number_axis - i))
                for i in range(1, 2): #3
                    if pieces.get(chr(ord(character_axis) - i) + str(number_axis + i)) in black_pieces:
                        break
                    elif pieces.get(chr(ord(character_axis) - i) + str(number_axis + i)) in white_pieces:
                        valid_locations.append(chr(ord(character_axis) - i) + str(number_axis + i))
                        break
                    valid_locations.append(chr(ord(character_axis) - i) + str(number_axis + i))
                for i in range(1, 2): #4
                    if pieces.get(chr(ord(character_axis) - i) + str(number_axis - i)) in black_pieces:
                        break
                    elif pieces.get(chr(ord(character_axis) - i) + str(number_axis - i)) in white_pieces:
                        valid_locations.append(chr(ord(character_axis) - i) + str(number_axis - i))
                        break
                    valid_locations.append(chr(ord(character_axis) - i) + str(number_axis - i))
                for i in range(len(valid_locations)):
                    if list(valid_locations[i])[0] not in alphabet or str(list(valid_locations[i])[1]) not in number_list or len(valid_locations[i]) > 2:
                        locations_to_remove.append(valid_locations[i])
                for i in range(len(locations_to_remove)):
                    if locations_to_remove[i] in valid_locations:
                        valid_locations.remove(locations_to_remove[i])
                print("Valid locations where you can move;", full_piece_name + ":\n" + str(valid_locations))
                if len(valid_locations) == 0:
                    print("Choose another piece")
                    choose_new_piece_black = True
                else:
                    choose_new_piece_black = False
                while True:
                    new_location = input("Where to move " + full_piece_name + "?: ")
                    if new_location in valid_locations:
                        print("Valid move")
                        pieces[new_location] = B_king
                        B_king_location = new_location
                        if to_move in black_tiles:
                           pieces[to_move] = black_square
                        else:
                            pieces[to_move] = white_square
                        break
                    elif new_location == "back":
                        choose_new_piece_black = True
                        break
                    else:
                        print("Invalid move")
        else:
            print("Black king is dead: White wins!")
            king_dead = True
            break
get_board() # displays end screen
print(visual_board)
useless = input() # so terminal doesn't close
#2/4/24 10:24 - fixed promotions of pawns messing up graveyard + queen movement in - character
#       10:40 - Fixed movement bugs for attackig, with messed up '-' and '+' operators

